## shadowsocks-libev 3.1.1+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(PROJECT_NAME shadowsocks-libev)
set(RELEASE_DATE 2017-11-20)
set(PROJECT_VERSION "3.1.1")
set(PROJECT_DESC "a lightweight secured socks5 proxy")
set(PROJECT_URL "https://shadowsocks.org")
set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
project(${PROJECT_NAME})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

#set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/out)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)
set(RUNTIME_SHARED_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/shared/bin)

set(CMAKE_MACOSX_RPATH TRUE)

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif ()
# Detect linux
if (UNIX AND NOT APPLE)
    set(LINUX TRUE)
endif ()

message(STATUS "Running cmake version ${CMAKE_VERSION}")

option(WITH_STATIC "build with static libraries." ON)

# Will set GIT_EXECUTABLE and GIT_FOUND
# find_package(Git)

# Run platform tests
include(${CMAKE_SOURCE_DIR}/cmake/configure.cmake)
configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
add_definitions(-DHAVE_CONFIG_H)

# pkg-config
configure_file(
        ${CMAKE_SOURCE_DIR}/cmake/shadowsocks-libev.pc.cmake
        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        @ONLY
)
install(FILES
        ${CMAKE_BINARY_DIR}/pkgconfig/shadowsocks-libev.pc
        DESTINATION pkgconfig
        )

# We need libcork,libipset headers
include_directories(libcork/include)
include_directories(libipset/include)
include_directories(libbloom/murmur2)
include_directories(libbloom)

set(LIBCORK_SOURCE
        libcork/src/libcork/cli/commands.c
        libcork/src/libcork/core/allocator.c
        libcork/src/libcork/core/error.c
        libcork/src/libcork/core/gc.c
        libcork/src/libcork/core/hash.c
        libcork/src/libcork/core/ip-address.c
        libcork/src/libcork/core/mempool.c
        libcork/src/libcork/core/timestamp.c
        libcork/src/libcork/core/u128.c
        libcork/src/libcork/core/version.c
        libcork/src/libcork/ds/array.c
        libcork/src/libcork/ds/bitset.c
        libcork/src/libcork/ds/buffer.c
        libcork/src/libcork/ds/dllist.c
        libcork/src/libcork/ds/file-stream.c
        libcork/src/libcork/ds/hash-table.c
        libcork/src/libcork/ds/managed-buffer.c
        libcork/src/libcork/ds/ring-buffer.c
        libcork/src/libcork/ds/slice.c
        libcork/src/libcork/posix/directory-walker.c
        libcork/src/libcork/posix/env.c
        libcork/src/libcork/posix/exec.c
        libcork/src/libcork/posix/files.c
        libcork/src/libcork/posix/process.c
        libcork/src/libcork/posix/subprocess.c
        libcork/src/libcork/pthreads/thread.c
        )

if (WITH_STATIC)
add_library(cork STATIC ${LIBCORK_SOURCE})
target_compile_definitions(cork PUBLIC -DCORK_API=CORK_LOCAL)
endif ()

add_library(cork-shared SHARED ${LIBCORK_SOURCE})
target_compile_definitions(cork-shared PUBLIC -DCORK_API=CORK_EXPORT)
set_target_properties(cork-shared PROPERTIES OUTPUT_NAME cork)

set(LIBIPSET_SOURCE
        libipset/src/libipset/general.c
        libipset/src/libipset/bdd/assignments.c
        libipset/src/libipset/bdd/basics.c
        libipset/src/libipset/bdd/bdd-iterator.c
        libipset/src/libipset/bdd/expanded.c
        libipset/src/libipset/bdd/reachable.c
        libipset/src/libipset/bdd/read.c
        libipset/src/libipset/bdd/write.c
        libipset/src/libipset/map/allocation.c
        libipset/src/libipset/map/inspection.c
        libipset/src/libipset/map/ipv4_map.c
        libipset/src/libipset/map/ipv6_map.c
        libipset/src/libipset/map/storage.c
        libipset/src/libipset/set/allocation.c
        libipset/src/libipset/set/inspection.c
        libipset/src/libipset/set/ipv4_set.c
        libipset/src/libipset/set/ipv6_set.c
        libipset/src/libipset/set/iterator.c
        libipset/src/libipset/set/storage.c
        )

if (WITH_STATIC)
add_library(ipset STATIC ${LIBIPSET_SOURCE})
endif ()

add_library(ipset-shared SHARED ${LIBIPSET_SOURCE})
set_target_properties(ipset-shared PROPERTIES OUTPUT_NAME ipset)

set(LIBBLOOM_SOURCE
        libbloom/bloom.c
        libbloom/murmur2/MurmurHash2.c
        )

if (WITH_STATIC)
add_library(bloom STATIC ${LIBBLOOM_SOURCE})
target_link_libraries(ipset cork bloom)
endif ()

add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
target_link_libraries(ipset-shared cork-shared bloom-shared)
set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)

add_subdirectory(src)
add_subdirectory(doc)

=== debian/changelog ===
shadowsocks-libev (3.1.1+ds-3) unstable; urgency=medium

  * debian/tests:
    - Since isolation-container still didn't work, change to
      "isolation-machine" and have a try.

 -- Roger Shimizu <rogershimizu@gmail.com>  Mon, 04 Dec 2017 22:48:32 +0900

shadowsocks-libev (3.1.1+ds-2) unstable; urgency=medium

  * debian/tests:
    - Add isolation-container to Restrictions, since the tests need to
      open ports. Thanks to James Cowgill for this clue.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 01 Dec 2017 22:29:45 +0900

shadowsocks-libev (3.1.1+ds-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 01 Dec 2017 00:57:17 +0900

shadowsocks-libev (3.1.1+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 01 Dec 2017 00:53:29 +0900

shadowsocks-libev (3.1.1+ds-1) unstable; urgency=medium

  * Release to unstable.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 26 Nov 2017 18:45:47 +0900

shadowsocks-libev (3.1.1+ds-1~exp2) experimental; urgency=medium

  * debian/patches:
    - Remove the temp fix to set TZ=UTC prefix for asciidoc command
      for reproducible build.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 26 Nov 2017 17:59:20 +0900

shadowsocks-libev (3.1.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release 3.1.1
  * debian/copyright:
    - Remove a few items from Files-Excluded list.
    - Update copyright year for src/uthash.h.
    - Add file entry for tests/test.py.
  * debian/watch:
    - Change filenamemangle to match with the filename in archive.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 23 Nov 2017 17:43:33 +0900

shadowsocks-libev (3.1.0+ds-5) unstable; urgency=medium

  * debian/patches:
    - Backport the tests.
  * debian/tests:
    - Add upstream tests.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 17 Nov 2017 01:39:53 +0900

shadowsocks-libev (3.1.0+ds-4~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 09 Nov 2017 00:52:06 +0900

shadowsocks-libev (3.1.0+ds-4~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 09 Nov 2017 00:51:12 +0900

shadowsocks-libev (3.1.0+ds-4) unstable; urgency=medium

  * Release to unstable.
  * debian/patches:
    - Backport a few patches from upstream.
      + [26ae365] Fix SOCKS5 connectivity issue.
      + [f35e24f] Support ubuntu artful and bionic for build_deb.sh.

 -- Roger Shimizu <rogershimizu@gmail.com>  Thu, 09 Nov 2017 00:17:45 +0900

shadowsocks-libev (3.1.0+ds-4~exp2) experimental; urgency=medium

  * debian/libshadowsocks-libev2.symbols:
    - Update versions in symbols, to it's proper old version in previous
      debian releases.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sun, 29 Oct 2017 18:51:15 +0900

shadowsocks-libev (3.1.0+ds-4~exp1) experimental; urgency=medium

  * debian/libshadowsocks-libev2.symbols:
    - setinterface doesn't exist on hurd and kfreebsd systems.

 -- Roger Shimizu <rogershimizu@gmail.com>  Fri, 27 Oct 2017 01:18:25 +0900

shadowsocks-libev (3.1.0+ds-3) unstable; urgency=medium

  * debian/libshadowsocks-libev2.symbols:
    - Add symbols file for libshadowsocks-libev2.
  * debian/control:
    - Bump up package priority from extra to optional, since policy states
      extra is the same as optional now.
    - Bump up Standards-Version to 4.1.1

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 25 Oct 2017 00:24:54 +0900

shadowsocks-libev (3.1.0+ds-2~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 24 Oct 2017 08:44:29 +0900

shadowsocks-libev (3.1.0+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rogershimizu@gmail.com>  Tue, 24 Oct 2017 08:43:09 +0900

shadowsocks-libev (3.1.0+ds-2) unstable; urgency=medium

  * debian/patches:
    - Backport a few patches from upstream.
      + [c67d275] Fix potential local exploit issue.
        Thanks to X41 D-Sec GmbH, Niklas Abel, for the reporting:
         https://www.x41-dsec.de/lab/advisories/x41-2017-010-shadowsocks-libev/
      + [b3f3b58] & [f19a96e] Fix two null pointer dereference.

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 18 Oct 2017 23:53:49 +0900

shadowsocks-libev (3.1.0+ds-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rogershimizu@gmail.com>  Sat, 14 Oct 2017 16:26:30 +0900

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: optional
Maintainer: Roger Shimizu <rogershimizu@gmail.com>
Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
Build-Depends:
 asciidoc-base | asciidoc,
 debhelper (>= 10),
 libbloom-dev,
 libc-ares-dev,
 libcork-dev (>= 0.15.0+ds-8),
 libcorkipset-dev,
 libev-dev,
 libmbedtls-dev,
 libpcre3-dev,
 libsodium-dev (>= 1.0.12),
 pkg-config,
 xmlto
Standards-Version: 4.1.1
Homepage: https://www.shadowsocks.org
Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/shadowsocks-libev.git

Package: shadowsocks-libev
Replaces: shadowsocks (<< 1.5.3-2)
Breaks: shadowsocks (<< 1.5.3-2)
Architecture: any
Depends:
 apg | pwgen,
 libcap2-bin [linux-any],
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 haveged,
 kcptun,
 simple-obfs
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.

Package: libshadowsocks-libev-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Breaks: shadowsocks-libev (<< 2.4.0)
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends}
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces: libshadowsocks-libev1
Breaks:
 libshadowsocks-libev1,
 shadowsocks-libev (<< 2.4.0)
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides shared libraries.

=== debian/tests/control ===
Test-Command: bash tests/test.sh
Depends: @, python, curl, dnsutils
Restrictions: allow-stderr, isolation-machine

## shadowsocks-libev 3.1.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-11-20)
-set(PROJECT_VERSION "3.1.1")
+set(RELEASE_DATE 2017-12-29)
+set(PROJECT_VERSION "3.1.2")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
@@ -36,7 +36,8 @@
 
 # Run platform tests
 include(${CMAKE_SOURCE_DIR}/cmake/configure.cmake)
-configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
+configure_file(${CMAKE_SOURCE_DIR}/cmake/config.h.cmake ${CMAKE_BINARY_DIR}/src/config.h)
+add_definitions(-I$(CMAKE_BINARY_DIR)/src)
 add_definitions(-DHAVE_CONFIG_H)
 
 # pkg-config

=== src/CMakeLists.txt ===
# redir need linux/* stuff
if (LINUX)
    option(WITH_SS_REDIR "Build ss-redir" ON)
else ()
    option(WITH_SS_REDIR "Build ss-redir" OFF)
endif ()


set(SS_SNI_SOURCE
        http.c
        tls.c
        rule.c
        )

set(SS_CRYPTO_SOURCE
        crypto.c
        aead.c
        stream.c
        base64.c
        )

set(SS_PLUGIN_SOURCE
        plugin.c
        )

set(SS_SHARED_SOURCES
        ppbloom.c
        utils.c
        jconf.c
        json.c
        netutils.c
        )

set(LIBSHADOWSOCKS_LIBEV_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        acl.c
        local.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE})

set(SS_LOCAL_SOURCE
        ${LIBSHADOWSOCKS_LIBEV_SOURCE}

        )

set(SS_TUNNEL_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        tunnel.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        )

set(SS_SERVER_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        acl.c
        resolv.c
        server.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        )

set(SS_MANAGER_SOURCE
        ${SS_SHARED_SOURCES}
        manager.c
        )

set(SS_REDIR_SOURCE
        ${SS_SHARED_SOURCES}
        udprelay.c
        cache.c
        redir.c
        ${SS_CRYPTO_SOURCE}
        ${SS_PLUGIN_SOURCE}
        ${SS_SNI_SOURCE}
        )


if (WITH_STATIC)
find_library(LIBSODIUM libsodium.a)
find_library(LIBMBEDTLS libmbedtls.a)
find_library(LIBMBEDCRYPTO libmbedcrypto.a)
find_library(LIBEV libev.a)
find_library(LIBUDNS libcares.a)
find_library(LIBPCRE libpcre.a)
endif ()

find_library(LIBSODIUM_SHARED sodium)
find_library(LIBMBEDTLS_SHARED mbedtls)
find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
find_library(LIBEV_SHARED ev)
find_library(LIBUDNS_SHARED cares)
find_library(LIBPCRE_SHARED pcre)

# Dependencies we need for static and shared
if (WITH_STATIC)
list(APPEND DEPS
        m
        bloom
        ${LIBEV}
        ${LIBUDNS}
        ${LIBPCRE}
        ${LIBSODIUM}
        ${LIBMBEDTLS}
        ${LIBMBEDCRYPTO}
        )
endif ()

list(APPEND DEPS_SHARED
        m
        bloom-shared
        ${LIBEV_SHARED}
        ${LIBUDNS_SHARED}
        ${LIBPCRE_SHARED}
        ${LIBSODIUM_SHARED}
        ${LIBMBEDTLS_SHARED}
        ${LIBMBEDCRYPTO_SHARED}
        )

find_package (Threads)

if (WITH_STATIC)
# ------------------------------------------------------------------
# Static
# By default we use normal name for static, all shared targets will add a `-shared' suffix
add_executable(ss-server ${SS_SERVER_SOURCE})
add_executable(ss-tunnel ${SS_TUNNEL_SOURCE})
add_executable(ss-manager ${SS_MANAGER_SOURCE})
add_executable(ss-local ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev STATIC ${LIBSHADOWSOCKS_LIBEV_SOURCE})


target_compile_definitions(ss-server PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server cork ipset ${DEPS})
target_link_libraries(ss-tunnel cork ${DEPS})
target_link_libraries(ss-manager m bloom cork ${LIBEV} ${LIBUDNS})
target_link_libraries(ss-local cork ipset ${DEPS})
target_link_libraries(ss-redir cork ipset ${DEPS})
target_link_libraries(shadowsocks-libev cork ipset ${DEPS})
endif ()

# ------------------------------------------------------------------
# Shared
# Shared target will have a `-shared' suffix
# All shared dependency also have `-shared' suffix
# For shared binary, we still use the same name as static, without `-shared', but will output to shared directory
add_executable(ss-server-shared ${SS_SERVER_SOURCE})
add_executable(ss-tunnel-shared ${SS_TUNNEL_SOURCE})
add_executable(ss-manager-shared ${SS_MANAGER_SOURCE})
add_executable(ss-local-shared ${SS_LOCAL_SOURCE})
if (WITH_SS_REDIR)
    add_executable(ss-redir-shared ${SS_REDIR_SOURCE})
else ()
    add_executable(ss-redir-shared EXCLUDE_FROM_ALL ${SS_REDIR_SOURCE})
endif ()
add_library(shadowsocks-libev-shared SHARED ${LIBSHADOWSOCKS_LIBEV_SOURCE})

target_compile_definitions(ss-server-shared PUBLIC -DMODULE_REMOTE)
target_compile_definitions(ss-tunnel-shared PUBLIC -DMODULE_TUNNEL)
target_compile_definitions(ss-manager-shared PUBLIC -DMODULE_MANAGER)
target_compile_definitions(ss-local-shared PUBLIC -DMODULE_LOCAL)
target_compile_definitions(ss-redir-shared PUBLIC -DMODULE_REDIR)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)

target_link_libraries(ss-server-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(ss-tunnel-shared cork-shared ${DEPS_SHARED})
target_link_libraries(ss-manager-shared m bloom-shared cork-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED})
target_link_libraries(ss-local-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(ss-redir-shared cork-shared ipset-shared ${DEPS_SHARED})
target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})

set_target_properties(ss-server-shared PROPERTIES OUTPUT_NAME ss-server)
set_target_properties(ss-tunnel-shared PROPERTIES OUTPUT_NAME ss-tunnel)
set_target_properties(ss-manager-shared PROPERTIES OUTPUT_NAME ss-manager)
set_target_properties(ss-local-shared PROPERTIES OUTPUT_NAME ss-local)
set_target_properties(ss-redir-shared PROPERTIES OUTPUT_NAME ss-redir)

set_target_properties(ss-server-shared ss-tunnel-shared ss-manager-shared ss-local-shared ss-redir-shared
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}
        )

set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})

# ------------------------------------------------------------------
# Misc
# Recommend to install shared by default
install(DIRECTORY ${RUNTIME_SHARED_OUTPUT_DIRECTORY}/
        DESTINATION bin)

if (WITH_STATIC)
    install(TARGETS shadowsocks-libev
        ARCHIVE DESTINATION lib)
endif ()

install(TARGETS shadowsocks-libev-shared
        LIBRARY DESTINATION lib)

install(FILES shadowsocks.h DESTINATION include)


add_custom_target(distclean
        COMMAND ${CMAKE_COMMAND} -E echo WARNING: distclean target is not functional
        COMMAND ${CMAKE_COMMAND} -E echo Use 'git clean -fdx' instead
        VERBATIM
        )

=== debian/changelog ===
shadowsocks-libev (3.1.2+ds-2) unstable; urgency=medium

  * debian/control:
    - Move git repo to salsa.
  * debian/rules:
    - Add more clean-up to make dpkg-buildpackage be able to run again.

 -- Roger Shimizu <rosh@debian.org>  Sun, 07 Jan 2018 15:38:11 +0900

shadowsocks-libev (3.1.2+ds-1) unstable; urgency=medium

  * New upstream release 3.1.2
  * debian/control:
    - Update maintainer email.
  * Update debian/libshadowsocks-libev2.symbols.

 -- Roger Shimizu <rosh@debian.org>  Tue, 02 Jan 2018 01:44:29 +0900

shadowsocks-libev (3.1.1+ds-4) unstable; urgency=medium

  * debian/tests:
    - Remove isolation-* from Restrictions. Thanks to Antonio Terceiro
      to confirm there's no need to specify this to open port to listen.
  * debian/patches:
    - Add patch to change the port of test suite to listen from 8388 to
      8389, since 8388 is already taken by default config.

 -- Roger Shimizu <rogershimizu@gmail.com>  Wed, 13 Dec 2017 00:39:52 +0900

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: shadowsocks-libev
 Section: net
 Priority: optional
-Maintainer: Roger Shimizu <rogershimizu@gmail.com>
+Maintainer: Roger Shimizu <rosh@debian.org>
 Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
 Build-Depends:
  asciidoc-base | asciidoc,
@@ -18,8 +18,8 @@
  xmlto
 Standards-Version: 4.1.1
 Homepage: https://www.shadowsocks.org
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/shadowsocks-libev.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/shadowsocks-libev.git
+Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev
+Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev
 
 Package: shadowsocks-libev
 Replaces: shadowsocks (<< 1.5.3-2)

## shadowsocks-libev 3.1.3%2Bds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2017-12-29)
-set(PROJECT_VERSION "3.1.2")
+set(RELEASE_DATE 2018-1-15)
+set(PROJECT_VERSION "3.1.3")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")
@@ -30,6 +30,7 @@
 message(STATUS "Running cmake version ${CMAKE_VERSION}")
 
 option(WITH_STATIC "build with static libraries." ON)
+option(WITH_EMBEDDED_SRC "build with embedded libcork, libipset, and libbloom source." ON)
 
 # Will set GIT_EXECUTABLE and GIT_FOUND
 # find_package(Git)
@@ -51,6 +52,7 @@
         DESTINATION pkgconfig
         )
 
+if (WITH_EMBEDDED_SRC)
 # We need libcork,libipset headers
 include_directories(libcork/include)
 include_directories(libipset/include)
@@ -137,6 +139,7 @@
 add_library(bloom-shared SHARED ${LIBBLOOM_SOURCE})
 target_link_libraries(ipset-shared cork-shared bloom-shared)
 set_target_properties(bloom-shared PROPERTIES OUTPUT_NAME bloom)
+endif ()
 
 add_subdirectory(src)
 add_subdirectory(doc)

## shadowsocks-libev 3.1.3+ds

=== doc/CMakeLists.txt ===
find_program(XMLTO_EXECUTABLE NAMES xmlto)
find_program(ASCIIDOC_EXECUTABLE NAMES asciidoc asciidoc.py)

# Opt-in doc build option
if (XMLTO_EXECUTABLE-NOTFOUND OR ASCIIDOC_EXECUTABLE-NOTFOUND)
    option(WITH_DOC_MAN "Build manpage doc" OFF)
else ()
    option(WITH_DOC_MAN "Build manpage doc" ON)
endif ()

if (ASCIIDOC_EXECUTABLE-NOTFOUND)
    option(WITH_DOC_HTML "Build html doc" OFF)
else ()
    option(WITH_DOC_HTML "Build html doc" ON)
endif ()


# NOTE For brew user, we have to setup this env var. see `brew info asciidoc'
set(XMLTO_ENV)
set(XMLTO_CATALOG_DIR_MACOS /usr/local/etc/xml/catalog)
if (EXISTS ${XMLTO_CATALOG_DIR_MACOS})
    set(XMLTO_ENV XML_CATALOG_FILES=${XMLTO_CATALOG_DIR_MACOS})
    message(STATUS "Detect xmlto catalog dir ${XMLTO_CATALOG_DIR_MACOS}")
endif ()

set(CMAKE_MANPAGE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/man)

set(DOC_DIR ${CMAKE_SOURCE_DIR}/doc)
set(XMLTO_OPTS -m ${DOC_DIR}/manpage-normal.xsl -m ${DOC_DIR}/manpage-bold-literal.xsl man)
set(ASCIIDOC_XML_OPTS -b docbook -d manpage -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})
set(ASCIIDOC_HTML_OPTS -b html4 -d article -f ${DOC_DIR}/asciidoc.conf -aversion=${PROJECT_VERSION})


set(MAN_NAMES ss-local.1 ss-manager.1 ss-nat.1 ss-redir.1 ss-server.1 ss-tunnel.1 shadowsocks-libev.8)
set(MAN_FILES)
set(HTML_FILES)

foreach (manfile IN LISTS MAN_NAMES)
    string(REGEX REPLACE \\.. .xml xmlfile ${manfile})
    string(REGEX REPLACE \\.. .asciidoc docfile ${manfile})
    string(REGEX REPLACE \\.. .html htmlfile ${manfile})

    set(docfile ${DOC_DIR}/${docfile})

    add_custom_command(OUTPUT ${manfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_XML_OPTS} -o ${xmlfile} ${docfile}
            COMMAND ${CMAKE_COMMAND} -E env ${XMLTO_ENV} ${XMLTO_EXECUTABLE} ${XMLTO_OPTS} ${xmlfile}
            # After we built the manpage, the xmlfile is nolongger needed
            COMMAND ${CMAKE_COMMAND} -E remove ${xmlfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/man
            COMMENT "Building manpage ${manfile}"
            VERBATIM)
    list(APPEND MAN_FILES ${manfile})

    add_custom_command(OUTPUT ${htmlfile}
            COMMAND ${ASCIIDOC_EXECUTABLE} ${ASCIIDOC_HTML_OPTS} -o ${htmlfile} ${docfile}
            DEPENDS ${docfile}
            WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/html
            COMMENT "Building htmlfile ${htmlfile}"
            VERBATIM)
    list(APPEND HTML_FILES ${htmlfile})
endforeach ()

add_custom_target(doc-man ALL DEPENDS ${MAN_FILES})
add_custom_target(doc-html ALL DEPENDS ${HTML_FILES})


if (NOT WITH_DOC_MAN)
    set_target_properties(doc-man PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/man/
            DESTINATION man)
endif ()
if (NOT WITH_DOC_HTML)
    set_target_properties(doc-html PROPERTIES EXCLUDE_FROM_ALL TRUE)
else ()
    install(DIRECTORY ${CMAKE_BINARY_DIR}/html/
            DESTINATION doc/html)
endif ()

# This is required for custom command
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/man)
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/html)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,10 @@
 set(SS_SNI_SOURCE
         http.c
         tls.c
+        )
+
+set(SS_ACL_SOURCE
+        acl.c
         rule.c
         )
 
@@ -35,11 +39,12 @@
         ${SS_SHARED_SOURCES}
         udprelay.c
         cache.c
-        acl.c
         local.c
         ${SS_CRYPTO_SOURCE}
         ${SS_PLUGIN_SOURCE}
-        ${SS_SNI_SOURCE})
+        ${SS_SNI_SOURCE}
+        ${SS_ACL_SOURCE}
+        )
 
 set(SS_LOCAL_SOURCE
         ${LIBSHADOWSOCKS_LIBEV_SOURCE}
@@ -59,12 +64,12 @@
         ${SS_SHARED_SOURCES}
         udprelay.c
         cache.c
-        acl.c
         resolv.c
         server.c
         ${SS_CRYPTO_SOURCE}
         ${SS_PLUGIN_SOURCE}
         ${SS_SNI_SOURCE}
+        ${SS_ACL_SOURCE}
         )
 
 set(SS_MANAGER_SOURCE
@@ -79,7 +84,6 @@
         redir.c
         ${SS_CRYPTO_SOURCE}
         ${SS_PLUGIN_SOURCE}
-        ${SS_SNI_SOURCE}
         )
 
 
@@ -90,17 +94,8 @@
 find_library(LIBEV libev.a)
 find_library(LIBUDNS libcares.a)
 find_library(LIBPCRE libpcre.a)
-endif ()
-
-find_library(LIBSODIUM_SHARED sodium)
-find_library(LIBMBEDTLS_SHARED mbedtls)
-find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
-find_library(LIBEV_SHARED ev)
-find_library(LIBUDNS_SHARED cares)
-find_library(LIBPCRE_SHARED pcre)
 
 # Dependencies we need for static and shared
-if (WITH_STATIC)
 list(APPEND DEPS
         m
         bloom
@@ -113,9 +108,19 @@
         )
 endif ()
 
+find_library(LIBSODIUM_SHARED sodium)
+find_library(LIBMBEDTLS_SHARED mbedtls)
+find_library(LIBMBEDCRYPTO_SHARED mbedcrypto)
+find_library(LIBEV_SHARED ev)
+find_library(LIBUDNS_SHARED cares)
+find_library(LIBPCRE_SHARED pcre)
+
+if (WITH_EMBEDDED_SRC)
 list(APPEND DEPS_SHARED
         m
         bloom-shared
+        cork-shared
+        ipset-shared
         ${LIBEV_SHARED}
         ${LIBUDNS_SHARED}
         ${LIBPCRE_SHARED}
@@ -123,6 +128,23 @@
         ${LIBMBEDTLS_SHARED}
         ${LIBMBEDCRYPTO_SHARED}
         )
+else ()
+find_library(LIBBLOOM_SHARED bloom)
+find_library(LIBCORK_SHARED cork)
+find_library(LIBCORKIPSET_SHARED corkipset)
+list(APPEND DEPS_SHARED
+        m
+        ${LIBBLOOM_SHARED}
+        ${LIBCORK_SHARED}
+        ${LIBCORKIPSET_SHARED}
+        ${LIBEV_SHARED}
+        ${LIBUDNS_SHARED}
+        ${LIBPCRE_SHARED}
+        ${LIBSODIUM_SHARED}
+        ${LIBMBEDTLS_SHARED}
+        ${LIBMBEDCRYPTO_SHARED}
+        )
+endif ()
 
 find_package (Threads)
 
@@ -180,12 +202,12 @@
 target_compile_definitions(ss-redir-shared PUBLIC -DMODULE_REDIR)
 target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
 
-target_link_libraries(ss-server-shared cork-shared ipset-shared ${DEPS_SHARED})
-target_link_libraries(ss-tunnel-shared cork-shared ${DEPS_SHARED})
-target_link_libraries(ss-manager-shared m bloom-shared cork-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED})
-target_link_libraries(ss-local-shared cork-shared ipset-shared ${DEPS_SHARED})
-target_link_libraries(ss-redir-shared cork-shared ipset-shared ${DEPS_SHARED})
-target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})
+target_link_libraries(ss-server-shared ${DEPS_SHARED})
+target_link_libraries(ss-tunnel-shared ${DEPS_SHARED})
+target_link_libraries(ss-manager-shared ${CMAKE_THREAD_LIBS_INIT} ${LIBEV_SHARED} ${LIBUDNS_SHARED} ${DEPS_SHARED})
+target_link_libraries(ss-local-shared ${DEPS_SHARED})
+target_link_libraries(ss-redir-shared ${DEPS_SHARED})
+target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})
 
 set_target_properties(ss-server-shared PROPERTIES OUTPUT_NAME ss-server)
 set_target_properties(ss-tunnel-shared PROPERTIES OUTPUT_NAME ss-tunnel)
@@ -200,7 +222,7 @@
 
 set_target_properties(shadowsocks-libev-shared PROPERTIES OUTPUT_NAME shadowsocks-libev)
 target_compile_definitions(shadowsocks-libev-shared PUBLIC -DMODULE_LOCAL)
-target_link_libraries(shadowsocks-libev-shared cork-shared ipset-shared ${DEPS_SHARED})
+target_link_libraries(shadowsocks-libev-shared ${DEPS_SHARED})
 
 # ------------------------------------------------------------------
 # Misc

=== debian/changelog ===
shadowsocks-libev (3.1.3+ds-1ubuntu2) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:46:20 +0000

shadowsocks-libev (3.1.3+ds-1ubuntu1) bionic; urgency=medium

  * debian/shadowsocks-libev.postinst:
    - setcap may fail in some contexts (e.g. autopkgtest using LXD).  In
      that case, issue a warning and carry on.
  * debian/patches/test-proxy-unsupported.patch:
    - Skip tests if an upstream HTTP proxy is set.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 01 Feb 2018 13:47:14 +0000

shadowsocks-libev (3.1.3+ds-1) unstable; urgency=medium

  * New upstream release 3.1.3

 -- Roger Shimizu <rosh@debian.org>  Wed, 17 Jan 2018 22:04:53 +0900

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: shadowsocks-libev
 Section: net
 Priority: optional
-Maintainer: Roger Shimizu <rosh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Roger Shimizu <rosh@debian.org>
 Uploaders: Max Lv <max.c.lv@gmail.com>, Boyuan Yang <073plan@gmail.com>
 Build-Depends:
  asciidoc-base | asciidoc,

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Dummy folder for autotools scripts
LIBDIR=libbloom libcork libipset

override_dh_auto_clean:
	# dh_auto_clean and dh_autoreconf complains if there're no these folders
	# they're removed after dh_autoreconf
	for libdir in ${LIBDIR}; do \
		mkdir -p $$libdir; \
		touch $$libdir/Makefile.in; \
	done
	dh_auto_clean
	# dpkg-buildpackage complains these files from previous built
	find -name Makefile -exec rm {} \;
	rm -f config.h config.log config.status libtool shadowsocks-libev.pc stamp-h1

override_dh_autoreconf:
	dh_autoreconf
	rm -rf ${LIBDIR}

override_dh_auto_configure:
	# Whether to have stack-protector is decided by dpkg-buildflags.
	# So --disable-ssp here should be safe. See Bug#829498
	dh_auto_configure -- \
		--enable-shared \
		--enable-system-shared-lib \
		--disable-ssp

override_dh_auto_install:
	find src/ -name '*.la' -delete
	dh_auto_install

%:
	dh $@

=== debian/tests/control ===
Test-Command: bash tests/test.sh
Depends: @, python, curl, dnsutils
Restrictions: allow-stderr

## shadowsocks-libev 3.2.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2018-1-15)
-set(PROJECT_VERSION "3.1.3")
+set(RELEASE_DATE 2018-5-28)
+set(PROJECT_VERSION "3.2.0")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.2.0+ds-5) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/control:
    - Update my email address and use the @debian.org one.
    - Bump Standards-Version to 4.2.1 (no changes needed).

  [ Roger Shimizu ]
  * debian/shadowsocks-libev.service (cherry-pick from upstream):
    - Add CapabilityBoundingSet: CAP_NET_BIND_SERVICE
  * debian/shadowsocks-libev*.service (cherry-pick from upstream):
    - Add AmbientCapabilities sames as CapabilityBoundingSet.
  * Move "tcp_and_udp" mode setting from init script / systemd service
    to config.json. Also add a NEWS about this change.
  * debian/patches: Backport a few patches from upstream.
    - [482040a] Fix a potential stackoverflow issue.
    - [92cab35] Add check for reusing server's nonce/salt.

 -- Roger Shimizu <rosh@debian.org>  Thu, 08 Nov 2018 02:16:23 +0900

shadowsocks-libev (3.2.0+ds-4) unstable; urgency=medium

  * debian/patches:
    - Backport two upstream patches to support IPv6 bind address in
      config, but no actual ipv6 network interface.
  * debian/config.json:
    - Add IPv6 loopback address ::1 to bind list. This should be no harm
      since the above two patches. (Closes: #881847)
  * Remove debian/source/lintian-overrides:
    - The only lintian override, license-problem-gfdl-invariants, was
      addressed after stretch. Guessing ftpmaster shouldn't complain this
      anymore.

 -- Roger Shimizu <rosh@debian.org>  Mon, 24 Sep 2018 00:32:10 +0900

shadowsocks-libev (3.2.0+ds-3) unstable; urgency=medium

  * debian/control:
    - Use tracker mail as uploader address.
  * debian/patches:
    - Add patch to fix of PATH_MAX for GNU/Hurd.
      Upstreamed already as [d88345fa].
  * debian/shadowsocks-libev.postinst & debian/control:
    - Drop apg and pwgen from Depends, use perl rand() snippet to
      generate password. Thanks to Shengjing Zhu (Closes: 900258).

 -- Roger Shimizu <rosh@debian.org>  Sun, 17 Jun 2018 11:19:11 +0900

shadowsocks-libev (3.2.0+ds-2) unstable; urgency=medium

  * debian/patches:
    - Cherry-pick patch from upstream that set default cipher to
      chacha20-ietf-poly1305, which was already debian package's default long
      before.
    - Add a patch to fix tests by using "local" setting instead of
      "local_address" in tests's config.

 -- Roger Shimizu <rosh@debian.org>  Sat, 09 Jun 2018 16:07:15 +0900

shadowsocks-libev (3.2.0+ds-1) unstable; urgency=medium

  * New upstream release.
    - Fix FTBFS against GCC 8. Closes: #897858.
    - Add support for XDG_CONFIG_HOME envvar.
    - Minor bug fixes.
  * debian/: Apply "wrap-and-sort -abst" for a uniformed format.
  * debian/control:
    - Bump Standards-Version to 4.1.4. (no changes needed)
  * debian/rules:
    - Use "dh_missing --fail-missing".
    - Remove unnecessary extra files before dh_install.
  * debian/copyright: Update copyright date information.
  * debian/patches: Refresh patches.
  * debian/shadowsocks-libev.install:
    - Also install zsh completions into system.

 -- Boyuan Yang <073plan@gmail.com>  Mon, 04 Jun 2018 17:48:46 +0800

shadowsocks-libev (3.1.3+ds-2) unstable; urgency=medium

  [ Sync from 3.1.3+ds-1ubuntu1 ]
  * debian/shadowsocks-libev.postinst:
    - setcap may fail in some contexts (e.g. autopkgtest using LXD).  In
      that case, issue a warning and carry on.
  * debian/patches/test-proxy-unsupported.patch:
    - Skip tests if an upstream HTTP proxy is set.

  [ Roger Shimizu ]
  * debian/patches: Backport a few patches from upstream.
    - [ed508ac] Fix no parse --fast-open in manager mode.
    - [b6faadf] Support TCP_NODELAY in manager mode.
    - [b361f75] Remove unused return value.
    - [1a21989] Remove the return value in traffic IPC.
    - [7b643dc] Invoke plugins direct instead of using "sh".
    - [9778ce2] Documentation improvements.
    - [fb22adc] Fix unsafe stripping of port from hostname in http.c
                (incompatibility SNI sniffing with IPv6).
    - [26e06a7] Fix bypassing repeated-salt check.
    - [e7ad7fc] udprelay: display mtu at least size.
    - [a377c51] Fix #1974 that ss-server should return a non-zero value
                if plugin failed to start.
    - [d61b8f0] Launch plugin with NULL params gives plugin to run in both
                plugin mode & cli mode.
  * A few bits change to comfort lintian:
    - Amend Vcs-Git field of debian/control.
    - Move debian/source.lintian-overrides to debian/source/lintian-overrides.

 -- Roger Shimizu <rosh@debian.org>  Wed, 21 Mar 2018 13:15:49 +0900

=== debian/control ===
Source: shadowsocks-libev
Section: net
Priority: optional
Maintainer: Roger Shimizu <rosh@debian.org>
Uploaders:
 Max Lv <max.c.lv@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Debian Bridges Team <team+bridges@tracker.debian.org>
Build-Depends:
 asciidoc-base | asciidoc,
 debhelper (>= 10),
 libbloom-dev,
 libc-ares-dev,
 libcork-dev (>= 0.15.0+ds-8),
 libcorkipset-dev,
 libev-dev,
 libmbedtls-dev,
 libpcre3-dev,
 libsodium-dev (>= 1.0.12),
 pkg-config,
 xmlto,
Standards-Version: 4.2.1
Homepage: https://www.shadowsocks.org
Vcs-Git: https://salsa.debian.org/bridges-team/shadowsocks-libev.git
Vcs-Browser: https://salsa.debian.org/bridges-team/shadowsocks-libev

Package: libshadowsocks-libev-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Breaks:
 shadowsocks-libev (<< 2.4.0),
Depends:
 libshadowsocks-libev2 (= ${binary:Version}),
 ${misc:Depends},
Description: lightweight and secure socks5 proxy (development files)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides C header files for the libraries.

Package: libshadowsocks-libev2
Architecture: any
Multi-Arch: same
Section: libs
Replaces:
 libshadowsocks-libev1,
Breaks:
 libshadowsocks-libev1,
 shadowsocks-libev (<< 2.4.0),
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: lightweight and secure socks5 proxy (shared library)
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.
 .
 This package provides shared libraries.

Package: shadowsocks-libev
Replaces:
 shadowsocks (<< 1.5.3-2),
Breaks:
 shadowsocks (<< 1.5.3-2),
Architecture: any
Depends:
 libcap2-bin [linux-any],
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 haveged,
 kcptun,
 simple-obfs,
Description: lightweight and secure socks5 proxy
 Shadowsocks-libev is a lightweight and secure socks5 proxy for
 embedded devices and low end boxes.
 .
 Shadowsocks-libev was inspired by Shadowsock (in Python). It's rewritten
 in pure C and only depends on libev, mbedTLS and a few other tiny
 libraries.

## shadowsocks-libev 3.2.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2018-5-28)
-set(PROJECT_VERSION "3.2.0")
+set(RELEASE_DATE 2018-11-8)
+set(PROJECT_VERSION "3.2.1")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.2.1+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Mon, 26 Nov 2018 23:56:45 +0900

shadowsocks-libev (3.2.1+ds-2) unstable; urgency=medium

  * debian/patches: Backport patch from upstream.
    - [569570c] Fix memory alignment for AES256GCM on 32-bit system.
    - [519776c] Relax the nonce check in clients.
    - [4a51c28] Fix udp relay when tcp only (for use with kcptun).
    - [910e29a] Make local address 0.0.0.0 work with udp relay.

 -- Roger Shimizu <rosh@debian.org>  Fri, 23 Nov 2018 00:59:18 +0900

shadowsocks-libev (3.2.1+ds-1) unstable; urgency=medium

  * New upstream release.
    - Add TCP fast open support to ss-tunnel by @PantherJohn.
    - Fix several security issues.
  * debian/libshadowsocks-libev2.symbols:
    - Remove keep_resolving.
    - Add ss_is_ipv6addr.

 -- Roger Shimizu <rosh@debian.org>  Mon, 12 Nov 2018 01:44:02 +0900

shadowsocks-libev (3.2.0+ds-5~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Sat, 10 Nov 2018 14:59:34 +0900

shadowsocks-libev (3.2.0+ds-3~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Wed, 20 Jun 2018 09:55:21 +0900

shadowsocks-libev (3.2.0+ds-3~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Wed, 20 Jun 2018 09:52:21 +0900

shadowsocks-libev (3.2.0+ds-2~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Wed, 13 Jun 2018 00:16:49 +0900

shadowsocks-libev (3.2.0+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Wed, 13 Jun 2018 00:16:24 +0900

shadowsocks-libev (3.1.3+ds-2~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Wed, 21 Mar 2018 13:52:23 +0900

shadowsocks-libev (3.1.3+ds-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Wed, 21 Mar 2018 13:51:51 +0900

shadowsocks-libev (3.1.3+ds-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Wed, 17 Jan 2018 22:22:56 +0900

shadowsocks-libev (3.1.3+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Wed, 17 Jan 2018 22:22:25 +0900

shadowsocks-libev (3.1.2+ds-1~bpo8+1) jessie-backports-sloppy; urgency=medium

  * Rebuild for jessie-backports-sloppy.

 -- Roger Shimizu <rosh@debian.org>  Sat, 06 Jan 2018 22:13:29 +0900

shadowsocks-libev (3.1.2+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Roger Shimizu <rosh@debian.org>  Sat, 06 Jan 2018 22:13:08 +0900

## shadowsocks-libev 3.2.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2018-11-8)
-set(PROJECT_VERSION "3.2.1")
+set(RELEASE_DATE 2018-11-27)
+set(PROJECT_VERSION "3.2.2")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.2.2+ds-1) unstable; urgency=medium

  * New upstream release: v3.2.2
    - Fix a bug on 32-bit arch.
  * debian/libshadowsocks-libev2.symbols:
    - Add s_port@Base

 -- Roger Shimizu <rosh@debian.org>  Wed, 28 Nov 2018 01:15:47 +0900

## shadowsocks-libev 3.2.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2018-11-27)
-set(PROJECT_VERSION "3.2.2")
+set(RELEASE_DATE 2018-11-28)
+set(PROJECT_VERSION "3.2.3")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.2.3+ds-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Dec 2018 20:18:53 -0500

shadowsocks-libev (3.2.3+ds-1) unstable; urgency=medium

  * New upstream release: v3.2.3
    - Fix the alignment issue again.
  * debian/maint-tools/README: Update packaging repo url.
  * debian/README.Debian: Update my email address.

 -- Boyuan Yang <byang@debian.org>  Sat, 01 Dec 2018 20:12:36 -0500

## shadowsocks-libev 3.2.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
 cmake_minimum_required(VERSION 3.2)
 
 set(PROJECT_NAME shadowsocks-libev)
-set(RELEASE_DATE 2018-11-28)
-set(PROJECT_VERSION "3.2.3")
+set(RELEASE_DATE 2019-02-26)
+set(PROJECT_VERSION "3.2.4")
 set(PROJECT_DESC "a lightweight secured socks5 proxy")
 set(PROJECT_URL "https://shadowsocks.org")
 set(PROJECT_ISSUES_URL "https://github.com/shadowsocks/shadowsocks-libev")

=== debian/changelog ===
shadowsocks-libev (3.2.4+ds-1) unstable; urgency=medium

  * New upstream release: v3.2.4
  * debian/control:
    + Bump Standards-Version to 4.3.0.
  * debian/shadowsocks-libev.postrm: Make the script more robust to
    fix the error on package purge.

 -- Boyuan Yang <byang@debian.org>  Fri, 01 Mar 2019 11:31:45 -0500
